//___________________________________________________________________
//
//                         BoxSizer Header
//___________________________________________________________________

extern Function 
	lBoxSizer, lBoxSizerDestroy,
	lBoxSizerAdd;

class BoxSizer: public wxBoxSizer
{
	public:
		BoxSizerNodeP boxSizerNode;

		BoxSizer(BoxSizerNodeP boxSizerNode_, int orient_);
		~BoxSizer();

		wxString wxstring();
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
};
typedef BoxSizer *BoxSizerP;

class BoxSizerNode: public Node
{
	public:
		BoxSizerP boxSizer;
		int orient;
		PairP children;

		static const BoxSizerNode aBoxSizerNode;

		operator_new;

		BoxSizerNode();

		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);
		void setPtrs(IntToPtr_ &intToPtr);
		void aftersetPtrs2();

		StringP string();
		wxString wxstring();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		StringP _typeof();

		void bigSwitch(NodeP arg, wxWindow *&win, wxSizer *&sizer);
		NodeP bigArgSwitch(NodeP arg, wxWindow *&win, wxSizer *&sizer);
};
