#ifndef Node_included
	#include "Node.h"
#endif

//#ifndef DL_included

class wxDynamicLibrary;

class DynamicLibrary: public Node
{
	StringP _name;
	public:
		wxDynamicLibrary *module;

		static const DynamicLibrary aDynamicLibrary;

		operator_new;

		StringP name() {return _name;}
		void setname(StringP nd);

		DynamicLibrary(): Node(DYNAMIC_LIB), module(0) {}
		DynamicLibrary(StringP name_, wxDynamicLibrary *module_);

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();
		void free();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);

		StringP _typeof();
};

extern Function lDynamicLibrary, lDynamicLibraryCall;

#define DL_included
//#endif
