
class DebugState;
typedef DebugState *DebugStateP;

class DebugStates
{
public:
	int size, active, first, last;
	DebugStateP base;
	static int defaultSize;
	static bool updateGraph;

	DebugStates();

	bool init(int size_);
	void free();

	void mark();	// Iterative mark procedure
	void markPtr(PtrToInt_ &ptrToInt);// mark and insert ptr into ptrToInt table

	void copyRoot();

	bool switchToNext();
	void switchToPrev();
	void switchToLast();
	void switchTo(int state);
};

extern DebugStates debugStates;
