#ifndef Node_included
	#include "Node.h"
#endif

class Recorder;

class GraphicNode: public Node
{
	public:
		Recorder *recorder;
		double scale;

		static const GraphicNode aGraphicNode;

		operator_new;
		GraphicNode(): Node(GRAPHIC) {}
		GraphicNode(Recorder *recorder_);

		void free();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		StringP string();
		StringP _typeof();

		void draw(Turtle *turtle);
};

#define Bitmap_included
