//___________________________________________________________________
//
//                          Mem Header
//___________________________________________________________________

extern Function 
	lGarbageCollect, lNodes, lloadNodes, lsaveNodes;

extern "C++" Export NodeP Unbound;

extern bool
	    is_nil_or_ok(volatile Node *nd), 
	is_valid_pointer(volatile Node *nd);

//===================================================================
#define MANY_NODES(x)		\
	x(GC_::SpareNode)			\
	x(_Not_Enough_node)		\
	x(File::Null  )			\
	x(File::StdIn ) x(File::StdOut) \
	x(File::ConIn ) x(File::ConOut) \
	x(File::CIn   ) x(File::COut  ) \
	x(File::list) x(File::TextCtrl) \
	x(EventChar   ::function)	\
	x(EventKeyDown::function)	\
	x(EventKeyUp  ::function)	\
	x(EventTextMouseLeftDown	::function)	\
	x(EventTextMouseRightDown	::function)	\
	x(EventTextMouseMiddleDown	::function)	\
	x(EventTextMouseLeftUp		::function)	\
	x(EventTextMouseRightUp		::function)	\
	x(EventTextMouseMiddleUp	::function)	\
	x(EventTextMouseLeftDClick	::function)	\
	x(EventTextMouseRightDClick::function)	\
	x(EventTextMouseMiddleDClick::function)\
	x(EventTextMouseMotion		::function)	\
	x(EventMouseLeftDown		::function)	\
	x(EventMouseRightDown	::function)	\
	x(EventMouseMiddleDown	::function)	\
	x(EventMouseLeftUp		::function)	\
	x(EventMouseRightUp		::function)	\
	x(EventMouseMiddleUp		::function)	\
	x(EventMouseLeftDClick	::function)	\
	x(EventMouseRightDClick	::function)	\
	x(EventMouseMiddleDClick::function)	\
	x(EventMouseMotion		::function)	\
	x(_ListEnd)

#define MANY_TH_NODES(x)		\
	x(th->nodeList		)	\
	x(th->line			)	\
	x(th->currentLine	)	\
	x(th->deependProcName) \
	x(th->throw_node	)  \
	x(th->err_msg		)	\
	x(th->fun			)	\
	x(th->ufun			)	\
	x(th->lexufun		)	\
	x(th->this_line	)	\
	x(th->thisobj		)	\
	x(th->parents		)	\
	x(th->last_ufun	)	\
	x(th->last_call	)	\
	x(th->last_line	)	\
	x(th->loopcond		)	\
	x(th->forname		)	\
	x(th->didnt_output_name) \
	x(th->output_node	)	\
	x(th->Reader		)	\
	x(th->Writer		)	\
	x(th->Loader		)	\
	x(th->Dribbler		)	\
	x(th->Stringbuffer)	\
	x(th->textControl	)	\
	x(th->filenames	)	\
	x(th->filename()	)	\
	x(th->namespce		)	\
	x(th->namespceobj	)	\
	x(th->user			)	\
	x(th->erract		)	\
	x(th->startup		)	\
	x(th->specialForms)	\
	x(th->logoLanguage)	\
	x(th->turtleNode	)	\
	x(th->gtTable		)	\
	x(_ListEnd			)

#define LIST_MANY(x) x,
#define LIST_MANY_ADDRESS(x) (NodePP)&x,
