#include "stdafx.h"

#include <math.h>

#include <wx/txtstrm.h>
#include <wx/datstrm.h>

#include "Main.h"
#include "Float.h"
#include "Point.h"

Point Point::abs()
{
	return Point(
		Float::abs(x), 
		Float::abs(y), 
		Float::abs(z));
}

Point Point::operator%(const float &b)
{	
	return Point(
		Float::mod(x, b), 
		Float::mod(y, b), 
		Float::mod(z, b));
}

Point Point::operator%(const Point &b)
{	
	return Point(
		Float::mod(x, b.x), 
		Float::mod(y, b.y), 
		Float::mod(z, b.z));
}
