
class PtrToInt
{
	class PtrIntPair;
	typedef PtrIntPair *PtrIntPairP;

	class PtrIntPair
	{
	public:
		int i;
		void *p;
		PtrIntPairP nxt, tail;

		PtrIntPair(void *p_, int i_, PtrIntPairP tail_):
			i(i_), p(p_), nxt(0), tail(tail_)
		{}

		~PtrIntPair() {if (tail) delete tail;}
	};

	int size, nr;
	PtrIntPairP *data, start, last;

public:
	PtrToInt(): size(0), nr(0), data(0), start(0), last(0) {}
	PtrToInt(int size_);
	~PtrToInt();

	int Nr() {return nr;}
	int hash(void *p);
	int find(void *p);
	int find(NodeP p) {return find((void*)p);}
	void insert(void *p);
	void insertNode(NodeP p);

	wxDataOutputStream &writeNodes(wxDataOutputStream &ostr);
};
