#ifndef Line_included
	#include "Line.h"
#endif

class Runparsed: public Line		// is a runparsed list
{
	public:
		RunparsedP _parsed;

		static const Runparsed aRunparsed;
		operator_new;

		Runparsed();
		Runparsed(NodeP first_, NodeP tail_);
		Runparsed(NodeP first_, NodeP tail_, NodeType type_);

		RunparsedP parsed()  {return _parsed;}
		void setparsed(NodeP nd);

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt); 
		void check_oldyoungs();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP _typeof();
};

#define Runparsed_included
