
enum SecurityBits
{	SECURITY_DLCALL	=1<<0,
	SECURITY_IODLL		=1<<1,
	SECURITY_SHELL		=1<<2,
	SECURITY_FILEWRITE=1<<3,
	SECURITY_FILEREAD	=1<<4,
	SECURITY_DIRS		=1<<5,
	SECURITY_THREAD	=1<<6,
	SECURITY_KEYBOARD	=1<<7,
	SECURITY_GUI		=1<<8,
	SECURITY_ERASE    =1<<9,
	SECURITY_CONNECT  =1<<10,
	SECURITY_GLOBAL   =1<<11,
	SECURITY_BURIED   =1<<12,
	SECURITY_NAMESPACE=1<<13,
	SECURITY_USER     =1<<14,
	SECURITY_LANGUAGE =1<<15,
};

class Security
{
public:
	union 
	{	unsigned int level;
		struct
		{	unsigned int
				dlcall     :1,
				iodll      :1,
				shell      :1,
				filewrite  :1,
				fileread   :1,
				dirs       :1,
				thread     :1,
				keyboard   :1,
				gui        :1,
				erase      :1,
				connect    :1,
				global     :1,
				buried     :1,
				namespce   :1,
				user       :1,
				language   :1;
		};
	};
	unsigned int
		stacksize, 
		recordsize,
		memsize, 
		nodes;
	int timeout;

	Security();
	bool operator<(const Security &b);
};
