//___________________________________________________________________
//
//                        Class Splitter
//___________________________________________________________________

class Splitter: public wxSplitterWindow
{
	public:
		double ratio;
		wxString name;
		bool inSetRatio;

		Splitter(wxWindow *parent, wxWindowID id = -1,
					const wxPoint& pos = wxDefaultPosition,
					const wxSize& size = wxDefaultSize,
					long style = wxSP_3D,
					const wxString& name_ = wxT("splitter")):
			wxSplitterWindow(parent, id, pos, size, style, name_),
			name(name_)
		{
			ratio=0;
			inSetRatio=false;
		}

		bool OnSashPositionChange(int newSashPosition);
		void
			OnSize(wxSizeEvent& event),
			setRatio(double y);

		DECLARE_EVENT_TABLE()
};
