
struct PrimType;

class StringToPtr
{
public:
	class PtrStringPair;
	typedef PtrStringPair *PtrStringPairP;

	class PtrStringPair
	{
	public:
		wxString s;
		void *p;
		PtrStringPairP tail;

		PtrStringPair(void *p_, wxString &s_, PtrStringPairP tail_):
			s(s_), p(p_), tail(tail_)
		{}

		~PtrStringPair() {if (tail) delete tail;}
	};

	int size, nr;
	PtrStringPairP *data;

	StringToPtr(): size(0), nr(0), data(0) {}
	StringToPtr(int size_);
	StringToPtr(int size_, PrimType *primitives);
	~StringToPtr();

	int hash(wxString &s);
	void *find(wxString &s);
	void insert(wxString s, void *p);
};
