#ifndef Node_included
	#include "Node.h"
#endif

#ifndef Struct_included

class Struct: public Node
{
	int size;
	ObjectP *base, _first;

	public:
		static const Struct aStruct;
		operator_new;

		ObjectP first() {return _first;}
		void setfirst(ObjectP nd) {_first=nd;  check_oldyoung(nd);}

		Struct(): Node(STRUCT), size(0), base(0), _first(0) {}
		Struct(PairP data_);
		void free();

		void inc_gc();
		int youngs();
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP string();
		void print(FILEP strm, int &width, int depth, int noBrackets=0, int noSpacers=0);
		void printBin(FILEP strm);

		void mark();
		void clean();

		int count();
		int _sizeof();
		StringP _typeof();
		NodeP item(NodeP index, NodeP result);
		NodeP setitem(NodeP index, NodeP newitem, bool safe);
		PairP list();
		NodeP readbin(FileP file);

		int hash(StringP str);
		ObjectP operator[](StringP str);
		ObjectP find(StringP str);
		ObjectP insert(StringP nd);
};

	#define Struct_included
#endif
