#ifndef Runparsed_included
	#include "Runparsed.h"
#endif

class Tree: public Runparsed
{
	protected:
		TreeP _tree;

	public:
		static bool dont_know_how_to;
		static const Tree aTree;
		operator_new;

		LineP tree() {return _tree;}
		TreeP tail() {return TreeP(_tail);}

		void settree(PairP tree_);

		Tree();
		Tree(NodeP first_, NodeP tail_);

		void inc_gc();
		int youngs(); 
		int youngsPtr(PtrToInt_ &ptrToInt);
		void check_oldyoungs();

		void untreeify();
		void setline(PairP nd);	// Set the line pointer for a tree.

		void setPtrs(IntToPtr_ &intToPtr);
		DataInputStream &read(DataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);

		StringP _typeof();
};

#define Tree_included
