//___________________________________________________________________
//
//                          Class Font
//___________________________________________________________________

class FTFont;
class Graph;

class Font_
{
	public:
		double sizex,sizey; 
		int weight, alignx, aligny;
		wxString name;
		FTFont *ftfont;

		Font_(); 
		~Font_();

		Font_ &operator=(const Font_ &b);
		void load(Graph *graph);

	friend TextInputStream &operator>>(TextInputStream &istr, Font_ &f);
	friend TextOutputStream &operator<<(TextOutputStream &ostr, Font_ &f);
	friend DataInputStream &operator>>(DataInputStream &istr, Font_ &f);
	friend wxDataOutputStream &operator<<(wxDataOutputStream &ostr, Font_ &f);
};
