#ifndef Node_included
	#include "Node.h"
#endif

class Procedure: public Node
{
	PairP _formals, _bodylist, _bodywords;
	ObjectP _object;

	public:
		char min, std, max;
		static const Procedure aProcedure;

		operator_new;
		Procedure() { }
		Procedure(PairP formals_, PairP bodylist_, PairP bodywords_, 
				ObjectP object_, char min_, char std_, char max_);

		PairP formals()  {return _formals;}
		PairP bodylist() {return _bodylist;}
		PairP bodywords(){return _bodywords;}
		ObjectP object() {return _object;}

		void setformals  (PairP nd) { _formals =nd;  check_oldyoung(nd);}
		void setbodylist (PairP nd) {_bodylist =nd;  check_oldyoung(nd);}
		void setbodywords(PairP nd) {_bodywords=nd;  check_oldyoung(nd);}

		void inc_gc() {fifo << formals() << bodylist() << bodywords();}
		int youngs() 
		{	return gmark(formals())
					+gmark(bodylist())
					+gmark(bodywords());
		}
		int youngsPtr(PtrToInt_ &ptrToInt) 
		{	return gmarkPtr(formals(), ptrToInt)
					+gmarkPtr(bodylist(), ptrToInt)
					+gmarkPtr(bodywords(), ptrToInt);
		}
		void check_oldyoungs() 
		{	check_oldyoung(formals()); 
			check_oldyoung(bodylist()); 
			check_oldyoung(bodywords());
		}

		void setPtrs(IntToPtr_ &intToPtr);
		wxDataInputStream &read(wxDataInputStream &istr);
		wxDataOutputStream &write(wxDataOutputStream &ostr);

		NodeP copy(PtrToInt_ &ptrToInt);
		void print(FILEP strm, int width, int depth);
		void printBin(FILEP strm);

		StringP _typeof();

		void untreeify();
		PairP get_bodywords(NodeP name);

		LineP gather_args(LinePP args, bool inparen, ObjectPP ifnode);

		static LineP gather_some_args(
			int min, int max, LinePP args, bool inparen, ObjectPP ifnode);
};

#define Procedure_included
